{
obj=$1;
nwrongword=0;
nwrongword+=gsub("/","",obj);
nwrongword+=gsub("*","",obj);
nwrongword+=gsub("&","",obj);
nwrongword+=gsub("%","",obj);
nwrongword+=gsub("?","",obj);
#nwrongword+=gsub("\[","",obj);
#nwrongword+=gsub("\]","",obj);
nwrongword+=gsub(";","",obj);
nwrongword+=gsub(":","",obj);
nwrongword+=gsub("#","",obj);
nwrongword+=gsub("!","",obj);
nwrongword+=gsub("[a-z]","[A-Z]",obj);
ra=$2;
dec=$3;
eq=$4;
pa=$5;
allfilter=$6;
allexp=$7;
allpat=$8;
alldith=$9;
allnframe=$10
mode=$11;
slit=$12;

if(slit=="-"){
  slit=prevslit;
}

if(slit>0.5){
  slit="NORMAL";
  slit2="2.0";
  saoshift="-4.0"
  prevslit=1;
}
else if(slit<=0.5){
  slit="NARROW";
  slit2="1.5";
  saoshift="-2.0";
  prevslit=0.5;
}


dith2=int(dith[1]/0.105/5/10)*10;

nf=split(allfilter,filter,",");
nexp=split(allexp,exptime,",");
nn=split(allnframe,nframe,",");
ndith=split(alldith,dith,",");
np=split(allpat,pat,",");
if(nf!=nexp){
  print("echo 'Error: Number of fields in column 6 and 7 should be same.'");
  exit 1;
}
if(nf!=nn){
  print("echo 'Error: Number of fields in column 6 and 10 should be same.'");
  exit 1;
}
   
if(nf!=ndith){
  for(i=1;i<=nf;i++) dith[i]=dith[1];
}

junk=allfilter
matchsp=gsub("Gr",junk,junk);
matchim=nf-matchsp

for(i=1;i<=np;i++){
  if(pat[i]=="IM4" || pat[i]=="IM8") pat[i]="IM2";
}
if(np<nf) {
  for(i=np+1;i<=nf;i++) pat[i]=pat[np];
}

if(matchim>0){
  if(mode=="OBJ"){
#proc1
    printf("sed 's/XOBJECTNAMEX/%s/g' %s/oope.objim1 | sed 's/XEXPOSUREX/%s/g' | sed 's/XFILTERX/%s/g'\n",obj,libdir,exptime[1],filter[1]);
    for(i=1;i<=nf;i++){
#extract the number of iteration of dithering
      nsplit=split(pat[i],temp,"*");
      spat=temp[1]; 
      if(nsplit > 1) npat=temp[2];
      else npat=1;
      if(filter[i]=="H" || filter[i]=="J") printf("sed 's/XOBJECTNAMEX/%s/g' %s/oope.objim2 | sed 's/XEXPOSUREX/%s/g' | sed 's/XFILTERX/%s/g'| sed 's/XDITHX/%s/g'| sed 's/XNFRAMEX/%s/g'|sed 's/XDITHPATTERNX/%s/g' | sed 's/XDITH2X/%s/g'\n",obj,libdir,exptime[i],filter[i],dith[i],nframe[i],spat,dith2);
#      print(spat);
      for(j=1;j<=npat;j++)
            if(filter[i]=="H" || filter[i]=="J") printf("sed 's/XOBJECTNAMEX/%s/g' %s/oope.objim3 | sed 's/XEXPOSUREX/%s/g' | sed 's/XFILTERX/%s/g'| sed 's/XDITHX/%s/g'| sed 's/XNFRAMEX/%s/g'|sed 's/XDITHPATTERNX/%s/g' | sed 's/XDITH2X/%s/g'\n",obj,libdir,exptime[i],filter[i],dith[i],nframe[i],spat,dith2);
    }
  }
  else if(mode=="STD"){
#proc1
    printf("sed 's/XOBJECTNAMEX/%s/g' %s/oope.stdim1 | sed 's/XEXPOSUREX/%s/g' | sed 's/XFILTERX/%s/g'\n",obj,libdir,exptime[1],filter[1]);
    for(i=1;i<=nf;i++){
      if(filter[i]=="H" || filter[i]=="J") printf("sed 's/XOBJECTNAMEX/%s/g' %s/oope.stdim2 | sed 's/XEXPOSUREX/%s/g' | sed 's/XFILTERX/%s/g'| sed 's/XDITHX/%s/g'| sed 's/XNFRAMEX/%s/g'|sed 's/XDITHPATTERNX/IM2/g'\n",obj,libdir,exptime[i],filter[i],dith[i],nframe[i]);
    }
  }
}

if(matchsp>0){
  if(mode=="OBJ"){
    spimfilter="H";

    printf("sed 's/XOBJECTNAMEX/%s/g' %s/oope.objsp1 | sed 's/XEXPOSUREX/%s/g' | sed 's/XFILTERX/%s/g'| sed 's/XSPFILTERX/%s/g'\n",obj,libdir,exptime[1],filter[1],spimfilter);
    for(i=1;i<=nf;i++){
#extract the number of iteration of dithering
      nsplit=split(pat[i],temp,"*");
      spat=temp[1]; 
      if(nsplit > 1) npat=temp[2];
      else npat=1;
      if(gsub("Gr","Gr",filter[i])>0) printf("sed 's/XOBJECTNAMEX/%s/g' %s/oope.objsp2 | sed 's/XEXPOSUREX/%s/g' | sed 's/XFILTERX/%s/g'| sed 's/XDITHX/%s/g'| sed 's/XNFRAMEX/%s/g'|sed 's/XDITHPATTERNX/%s/g'|sed 's/XSLITX/%s/g' |sed 's/XSLIT2X/%s/g'\n",obj,libdir,exptime[i],filter[i],dith[i],nframe[i],spat,slit,slit2);
      for(j=1;j<=npat;j++)
            if(gsub("Gr","Gr",filter[i])>0) printf("sed 's/XOBJECTNAMEX/%s/g' %s/oope.objsp3 | sed 's/XEXPOSUREX/%s/g' | sed 's/XFILTERX/%s/g'| sed 's/XDITHX/%s/g'| sed 's/XNFRAMEX/%s/g'|sed 's/XDITHPATTERNX/%s/g'|sed 's/XSLITX/%s/g' |sed 's/XSLIT2X/%s/g'\n",obj,libdir,exptime[i],filter[i],dith[i],nframe[i],spat,slit,slit2);
    }
  }
  else if(mode=="STD"){
    printf("sed 's/XOBJECTNAMEX/%s/g' %s/oope.stdsp1 | sed 's/XEXPOSUREX/%s/g' | sed 's/XFILTERX/%s/g' | sed 's/XDITHX/%s/g' | sed 's/XSAOSHIFTX/%s/g' | sed 's/XNFRAMEX/%s/g' \n",obj,libdir,exptime[1],filter[1],dith[1],saoshift,nframe[1]);
#    for(i=1;i<=nf;i++){
#      if(gsub("Gr","Gr",filter[i])>0) printf("sed 's/XOBJECTNAMEX/%s/g' %s/oope.stdsp2 | sed 's/XEXPOSUREX/%s/g' | sed 's/XFILTERX/%s/g'| sed 's/XDITHX/%s/g'| sed 's/XNFRAMEX/%s/g'|sed 's/XDITHPATTERNX/%s/g' |sed 's/XSLITX/%s/g'\n",obj,libdir,exptime[i],filter[i],dith[i],nframe[i],pat[i],slit);
#    }
  }
}
}
